﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Web.Http;

namespace HalMediaType
{
    public class ProductCatalogController : ApiController
    {
        public Products Get()
        {
            var products = GetProducts();
            return products;            
        }
       
        public Product Get(int id)
        {
            var products = GetProducts();
            return products.FirstOrDefault(p => p.Id == id);
        }

        private Products GetProducts()
        {
            var products = new Products
            {
                new Product
                {
                    Id = 1,
                    Name = "Product 1",
                    UnitPrice = 5.34M,
                },
                new Product
                {
                    Id = 2,
                    Name = "Product 2",
                    UnitPrice = 10,
                }
            };

            foreach (var product in products)
            {
                product.HRef = Url.Route("products",
                      new
                      {
                          id = product.Id
                      });

                var addCart = new Link
                {
                    Rel = "add-cart",
                    HRef = Url.Route("cart",
                      new
                      {
                      })
                };

                product.Links.Add(addCart);
            }

            products.HRef = Url.Route("products",
                      new
                      {
                      });

            return products;
        }
    }
}
